# Desarrollo de Aplicaciones Distribuidas

En este repositorio se encuentra el código con ejemplos y ejercicios resueltos de las diferentes partes de la asignatura "Desarrollo de Aplicaciones Distribuidas" del Grado en Ingeniería de Computadores de la ETSII URJC.

El contenido del repositorio se distribuye bajo licencia [Apache-2.0](https://github.com/codeurjc/dad/blob/main/LICENSE).

## El temario de la asignatura se divide en 5 partes

### Parte 1: Patrones arquitectónicos de aplicaciones distribuidas

* Tema 1: Introducción a las aplicaciones distribuidas
* Tema 2: Patrones arquitectónicos de aplicaciones distribuidas

Este tema no dispone de ejemplos o ejercicios en código.

### Parte 2. Desarrollo de aplicaciones web: Java, Spring y MySQL

* Tema 1: Desarrollo web con Spring
* Tema 2: APIs REST con Spring
* Tema 3: Bases de datos con Spring
* Tema 4: Seguridad en Spring
* Tema 5: Despliegue Spring

Los ejemplos y ejercicios de esta parte pueden encontrarse en [Parte 2](https://github.com/codeurjc/dad/tree/main/parte_2)

### Parte 3. Tecnologías de comunicación de aplicaciones distribuidas

* Tema 1: Comunicación mediante mensajes
* Tema 2: Protocolos de comunicación de bajo nivel

Los ejemplos y ejercicios de esta parte pueden encontrarse en [Parte 3](https://github.com/codeurjc/dad/tree/main/parte_3)

### Parte 4. Despliegue de aplicaciones web

* Tema 1. Virtualización, Cloud Computing y Contenedores
* Tema 2. Docker
* Tema 3. Docker Compose
* Tema 4. OpenStack

Los ejemplos y ejercicios de esta parte pueden encontrarse en [Parte 4](https://github.com/codeurjc/dad/tree/main/parte_4)

### Parte 5. Escalabilidad y tolerancia a fallos
* Tema 1. Introducción
* Tema 2. Cliente/Servidor
* Tema 3. Servidor con caché
* Tema 4. Balanceo de carga
* Tema 5. Replicación de bases de datos y otras arquitecturas escalables
* Tema 6. Bases de datos distribuidas
* Tema 7. Puesta en producción

Los ejemplos y ejercicios de esta parte pueden encontrarse en [Parte 5](https://github.com/codeurjc/dad/tree/main/parte_5)

### Proyectos de ejemplo

El objetivo de la asignatura es que los alumnos desarrollen una aplicación web como si estuvieran trabajando profesionalmente. Los alumnos desarrollarán la aplicación web en grupos, y será entregada por fases. Podemos encontrar proyectos de ejemplo de las diferentes fases de la práctica en [Proyectos de Ejemplo](https://github.com/codeurjc/dad/tree/main/proyectos_de_ejemplo)